        page    132,60
;****************************************************************************
;       FLTR_TST.ASM
;       Test program for the external memory, analog circuitry, and OnCE
;       Port circuitry of the DSP56002EVM evaluation board
;
;       Copywrite (c) MOTOROLA 1994
;                     Semiconductor Products Sector
;                     Digital Signal Processing Division
;
;****************************************************************************



        include 'initial.asm'
TONE_OUTPUT     EQU     HEADPHONE_EN+LINEOUT_EN+(0*LEFT_ATTN)+(0*RIGHT_ATTN)
NOISE_OUTPUT    EQU     HEADPHONE_EN+LINEOUT_EN
TONE_INPUT      EQU     MIC_IN_SELECT+(15*MONITOR_ATTN)+(4*LEFT_GAIN)+(4*RIGHT_GAIN)
NOISE_INPUT     EQU     MIC_IN_SELECT+(15*MONITOR_ATTN)+(15*LEFT_GAIN)+(15*RIGHT_GAIN)
ValA            EQU     0
ValB            EQU     $124f80
delta           EQU     $9c40
up              EQU     50
down            EQU     50

        org     p:
MAIN_PRG
noise_ini
        move    #$0,x0
        move    x0,x:TXBUFFER
        move    x0,x:TXBUFFER+1
        move    #NOISE_OUTPUT,x0
        move    x0,x:TXBUFFER+2
        move    #NOISE_INPUT,x0
        move    x0,x:TXBUFFER+3
;        move    #$ffff,m4
;        move    #$0,r4

        clr     a
        clr     b


        move    #delta,x0
        move    #0,y0
        move    #0,y1

noise_loop1
        jset    #2,x:SSISR,*            ; Wait for frame sync to pass.
        jclr    #2,x:SSISR,*            ; Wait for frame sync.
        nop

        move    #0,y0

        add     x0,a
        move    #ValB,b
        cmp     a,b
        jsset   #0,SR,noise_up

        move    a,x:TXBUFFER
        move    a,x:TXBUFFER+1

;        move    a,y:(r4)+

        jmp     noise_loop1

noise_loop2
        jset    #2,x:SSISR,*            ; Wait for frame sync to pass.
        jclr    #2,x:SSISR,*            ; Wait for frame sync.
        nop

        move    #0,y0

        sub     x0,a
        move    #ValA,b

        cmp     b,a
        jsset   #3,SR,noise_down

        move    a,x:TXBUFFER
        move    a,x:TXBUFFER+1

;        move    a,y:(r4)+

        jmp     noise_loop2

noise_up
        jset    #2,x:SSISR,*            ; Wait for frame sync to pass.
        jclr    #2,x:SSISR,*            ; Wait for frame sync.
        nop

        move    a,y1
        clr     a
        move    y0,a0

        inc     a
        move    a0,y0
        move    y1,a
        move    #0,y1

        move    #>up,b
        cmp     y0,b
        jsset   #3,SR,noise_loop2

        move    a,x:TXBUFFER
        move    a,x:TXBUFFER+1

;        move    a,y:(r4)+

        jmp     noise_up

noise_down
        jset    #2,x:SSISR,*            ; Wait for frame sync to pass.
        jclr    #2,x:SSISR,*            ; Wait for frame sync.
        nop

        move    a,y1
        clr     a
        move    y0,a0

        inc     a
        move    a0,y0
        move    y1,a
        move    #3,y1

        move    #>down,b
        cmp     y0,b
        jsset   #0,SR,noise_loop1

        move    a,x:TXBUFFER
        move    a,x:TXBUFFER+1

;        move    a,y:(r4)+

        jmp     noise_down